PingAuthorize API Reference

Export Snapshot

POST {{apiPath}}/snapshot/{{snapshotId}}/export

The POST /snapshot/{{snapshotId}}/export operation exports a snapshot as a file with the .snapshot extension. By default, the entire snapshot is exported. You can also specify a collection of policy, Trust Framework, Library, and Test Suite entities to export as a partial snapshot. For more information, refer to the Snapshot entity reference.

The sample request demonstrates a partial export operation.

Request Model

For property descriptions, refer to Snapshot service data model.

Property Type Required

<objectType>

Snapshot Entity[]

Optional

Headers

Content-Type      application/json

x-user-id      {{userId}}

Body

raw ( application/json )

[
  {
    "id": "{{policySetId}}",
    "type": "PolicySet",
    "includeChildren": true
  }
]

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{apiPath}}/snapshot/{{snapshotId}}/export' \
--header 'x-user-id: {{userId}}' \
--header 'Content-Type: application/json' \
--data '[
  {
    "id": "{{policySetId}}",
    "type": "PolicySet",
    "includeChildren": true
  }
]'
var options = new RestClientOptions("{{apiPath}}/snapshot/{{snapshotId}}/export")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("x-user-id", "{{userId}}");
request.AddHeader("Content-Type", "application/json");
var body = @"[" + "\n" +
@"  {" + "\n" +
@"    ""id"": ""{{policySetId}}""," + "\n" +
@"    ""type"": ""PolicySet""," + "\n" +
@"    ""includeChildren"": true" + "\n" +
@"  }" + "\n" +
@"]" + "\n" +
@"";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/snapshot/{{snapshotId}}/export"
  method := "POST"

  payload := strings.NewReader(`[
  {
    "id": "{{policySetId}}",
    "type": "PolicySet",
    "includeChildren": true
  }
]`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("x-user-id", "{{userId}}")
  req.Header.Add("Content-Type", "application/json")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /snapshot/{{snapshotId}}/export HTTP/1.1
Host: {{apiPath}}
x-user-id: {{userId}}
Content-Type: application/json

[
  {
    "id": "{{policySetId}}",
    "type": "PolicySet",
    "includeChildren": true
  }
]
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "[\n  {\n    \"id\": \"{{policySetId}}\",\n    \"type\": \"PolicySet\",\n    \"includeChildren\": true\n  }\n]\n");
Request request = new Request.Builder()
  .url("{{apiPath}}/snapshot/{{snapshotId}}/export")
  .method("POST", body)
  .addHeader("x-user-id", "{{userId}}")
  .addHeader("Content-Type", "application/json")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/snapshot/{{snapshotId}}/export",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "x-user-id": "{{userId}}",
    "Content-Type": "application/json"
  },
  "data": JSON.stringify([
    {
      "id": "{{policySetId}}",
      "type": "PolicySet",
      "includeChildren": true
    }
  ]),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/snapshot/{{snapshotId}}/export',
  'headers': {
    'x-user-id': '{{userId}}',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify([
    {
      "id": "{{policySetId}}",
      "type": "PolicySet",
      "includeChildren": true
    }
  ])

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/snapshot/{{snapshotId}}/export"

payload = json.dumps([
  {
    "id": "{{policySetId}}",
    "type": "PolicySet",
    "includeChildren": True
  }
])
headers = {
  'x-user-id': '{{userId}}',
  'Content-Type': 'application/json'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/snapshot/{{snapshotId}}/export');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'x-user-id' => '{{userId}}',
  'Content-Type' => 'application/json'
));
$request->setBody('[\n  {\n    "id": "{{policySetId}}",\n    "type": "PolicySet",\n    "includeChildren": true\n  }\n]');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/snapshot/{{snapshotId}}/export")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["x-user-id"] = "{{userId}}"
request["Content-Type"] = "application/json"
request.body = JSON.dump([
  {
    "id": "{{policySetId}}",
    "type": "PolicySet",
    "includeChildren": true
  }
])

response = http.request(request)
puts response.read_body
let parameters = "[\n  {\n    \"id\": \"{{policySetId}}\",\n    \"type\": \"PolicySet\",\n    \"includeChildren\": true\n  }\n]"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/snapshot/{{snapshotId}}/export")!,timeoutInterval: Double.infinity)
request.addValue("{{userId}}", forHTTPHeaderField: "x-user-id")
request.addValue("application/json", forHTTPHeaderField: "Content-Type")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()